// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from dbw_fca_msgs:msg/ThrottleReport.idl
// generated code does not contain a copyright notice

#ifndef DBW_FCA_MSGS__MSG__DETAIL__THROTTLE_REPORT__TRAITS_HPP_
#define DBW_FCA_MSGS__MSG__DETAIL__THROTTLE_REPORT__TRAITS_HPP_

#include "dbw_fca_msgs/msg/detail/throttle_report__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'watchdog_counter'
#include "dbw_fca_msgs/msg/detail/watchdog_counter__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const dbw_fca_msgs::msg::ThrottleReport & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_yaml(msg.header, out, indentation + 2);
  }

  // member: pedal_input
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pedal_input: ";
    value_to_yaml(msg.pedal_input, out);
    out << "\n";
  }

  // member: pedal_cmd
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pedal_cmd: ";
    value_to_yaml(msg.pedal_cmd, out);
    out << "\n";
  }

  // member: pedal_output
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pedal_output: ";
    value_to_yaml(msg.pedal_output, out);
    out << "\n";
  }

  // member: enabled
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "enabled: ";
    value_to_yaml(msg.enabled, out);
    out << "\n";
  }

  // member: override
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "override: ";
    value_to_yaml(msg.override, out);
    out << "\n";
  }

  // member: driver
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "driver: ";
    value_to_yaml(msg.driver, out);
    out << "\n";
  }

  // member: timeout
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "timeout: ";
    value_to_yaml(msg.timeout, out);
    out << "\n";
  }

  // member: watchdog_counter
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "watchdog_counter:\n";
    to_yaml(msg.watchdog_counter, out, indentation + 2);
  }

  // member: fault_wdc
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "fault_wdc: ";
    value_to_yaml(msg.fault_wdc, out);
    out << "\n";
  }

  // member: fault_ch1
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "fault_ch1: ";
    value_to_yaml(msg.fault_ch1, out);
    out << "\n";
  }

  // member: fault_ch2
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "fault_ch2: ";
    value_to_yaml(msg.fault_ch2, out);
    out << "\n";
  }

  // member: fault_power
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "fault_power: ";
    value_to_yaml(msg.fault_power, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const dbw_fca_msgs::msg::ThrottleReport & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<dbw_fca_msgs::msg::ThrottleReport>()
{
  return "dbw_fca_msgs::msg::ThrottleReport";
}

template<>
inline const char * name<dbw_fca_msgs::msg::ThrottleReport>()
{
  return "dbw_fca_msgs/msg/ThrottleReport";
}

template<>
struct has_fixed_size<dbw_fca_msgs::msg::ThrottleReport>
  : std::integral_constant<bool, has_fixed_size<dbw_fca_msgs::msg::WatchdogCounter>::value && has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<dbw_fca_msgs::msg::ThrottleReport>
  : std::integral_constant<bool, has_bounded_size<dbw_fca_msgs::msg::WatchdogCounter>::value && has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<dbw_fca_msgs::msg::ThrottleReport>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // DBW_FCA_MSGS__MSG__DETAIL__THROTTLE_REPORT__TRAITS_HPP_
